<?php

class appPointPackListener {

    public static function preExecuteOrderSave(sfEvent $event) {
        if (!appPointPack::isActive()) return false;

        $billing = $event->getSubject()->getRequest()->getParameter('user_data_billing');
        $delivery = $event->getSubject()->getRequest()->getParameter('user_data_delivery');

        if (!empty($billing['pointpack_point_number'])) {
            $delivery['company'] = $billing['company'];
            $delivery['address'] = $billing['address'];
            $delivery['code'] = $billing['code'];
            $delivery['town'] = $billing['town'];
            $delivery['customer_type'] = $billing['customer_type'];
            $event->getSubject()->getRequest()->setParameter('user_data_delivery', $delivery);
        }
    }

    public static function postExecuteOrderSave(sfEvent $event) {
        if (!appPointPack::isActive()) return false;

        $number = $event->getSubject()->getRequestParameter('user_data_billing[pointpack_point_number]');
        $event->getSubject()->order->getOrderDelivery()->setPointpackNumber($number);

        if ($point = appPointPackPoints::getPoint($number)) {
            $d = $event->getSubject()->order->getOrderUserDataDelivery();
            $d->setCompany('PointPack.pl S.A. - '.$point['name']);
            $d->setAddress($point['fullAddress']);
            $d->setCode($point['address']['zipCode']);
            $d->setTown($point['address']['city']);
            $d->save();
        }
    }

    public static function postOrderConfirm(sfEvent $event) {
        if (!appPointPack::isActive()) return false;
        
        if ($point = appPointPackPoints::getPoint($event->getSubject()->getRequestParameter('user_data_billing[pointpack_point_number]'))) {
            $data = array('company' => 'PointPack.pl S.A. - '.$point['name'],
                          'address' => $point['fullAddress'],
                          'code' => $point['address']['zipCode'],
                          'town' => $point['address']['city'],
                          'customer_type' => '2',
                        );
            $event->getSubject()->user_data_delivery = array_merge($event->getSubject()->user_data_delivery, $data);
        }
    }

    public static function generateStDelivery(sfEvent $event) {
        $event->getSubject()->attachAdminGeneratorFile('appPointPackPlugin', 'stDelivery.yml');
    }

    public static function postUpdateDeliveryFromRequest(sfEvent $event) {
        $delivery = $event->getSubject()->delivery;
        $request = $event->getSubject()->getRequestParameter('delivery');

        if ($request['pointpack_use_price'])
            $delivery->setPointpackUsePrice(true);
        else {
            $delivery->setPointpackPrice(null);
            $delivery->setPointpackUsePrice(false);
        }

        if ($request['pointpack_use_return_price'])
            $delivery->setPointpackUseReturnPrice(true);
        else  {
            $delivery->setPointpackReturnPrice(null);
            $delivery->setPointpackUseReturnPrice(false);
        }
    }
}
