<?php

class appPointPackFrontendActions extends stActions {

    public function executeShowMap() {
        $this->setLayout(false);
        
        $this->config = stConfig::getInstance('appPointPackPlugin');

        $delivery = DeliveryPeer::retrieveByPK($this->getRequestParameter('deliveryId'));

        if (is_object($delivery) && preg_match('/\-COD$/', $delivery->getPointpackMethod())) {
            $this->pointsNamespace = 'COD';
        } else {
            $this->pointsNamespace = 'ALL';
        }
    }

    public function executeGetPoints() {
        $i18n = $this->getContext()->getI18n();
        $this->setLayout(false);

        if ($this->getRequestParameter('pointsNamespace', 'ALL') == 'COD') {
            $data = appPointPackPoints::getListOfCodPoints();
        } else {
            $data = appPointPackPoints::getListOfPoints();
        }

        foreach ($data as $key => $marker) {
            if ($marker['state'] != 'OPEN') {
                unset($data[$key]);
                continue;
            }

            unset($data[$key]['phone']);
            unset($data[$key]['province']);
            $a = $marker['address'];
            $data[$key]['fullAddress'] = $a['street'] . ' ' . $a['houseNumber'] . (!empty($a['apartmentNumber']) ? '/' . $a['apartmentNumber'] : '');
            $data[$key]['postCodeCity'] = $a['zipCode'] . ' ' . $a['city'];
            unset($data[$key]['address']);

            foreach(array('WORKDAY', 'SATURDAY', 'SUNDAY_AND_HOLIDAYS') as $type) {
                if (isset($marker   ['open'][$type])) {
                    foreach($marker['open'][$type] as $keyTime => $time)
                        foreach($time as $timeName => $timeValue)
                            $data[$key]['open'][$type][$keyTime][$timeName] = (($timeValue < 10) ? '0'.$timeValue : $timeValue);

                    $data[$key]['open'][$type] = $data[$key]['open'][$type]['opening']['hour'].':'.$data[$key]['open'][$type]['opening']['minute'].' - '.$data[$key]['open'][$type]['closing']['hour'].':'.$data[$key]['open'][$type]['closing']['minute'];
                } else
                    $data[$key]['open'][$type] = $i18n->__('nieczynne');
            }
        }

        echo json_encode($data);
        exit();
    }

    public function executeGetPoint() {
        $this->setLayout(false);

        if ($this->getRequest()->hasParameter('number'))
            echo json_encode(appPointPackPoints::getPoint($this->getRequestParameter('number')));

        exit();
    }
}
