<?php
class appPointPackFrontendComponents extends sfComponents {

    public function executeSelectPointsButton() {
        if(appPointPack::isActive() === false)
            return sfView::NONE;

        $this->smarty = new stSmarty('appPointPackFrontend');

        $this->number = sfContext::getInstance()->getRequest()->getParameter('user_data_billing[pointpack_point_number]');
        $this->config = stConfig::getInstance('appPointPackPlugin');
        
        $this->isSecure = $this->getRequest()->isSecure();
    }

    public function executeBasketTerms() {
        if(appPointPack::isActive() === false)
            return sfView::NONE;

        $this->smarty = new stSmarty('appPointPackFrontend');
        $this->number = sfContext::getInstance()->getRequest()->getParameter('user_data_billing[pointpack_point_number]');
        $this->terms = sfContext::getInstance()->getRequest()->getParameter('user_data_billing[pointpack_terms]');
    }

    public function executeDeliveryOnBasketList() {
        if(appPointPack::isActive() === false || !$this->delivery->getPointpackMethod() || $this->delivery->getPointpackMethod() == 'NONE') 
            return sfView::NONE;
        
        if (preg_match('/\-COD$/', $this->delivery->getPointpackMethod()) && count(appPointPackPoints::getListOfCodPoints()) == 0)
            return sfView::NONE;

        $this->smarty = new stSmarty('appPointPackFrontend');

        $this->id = $this->delivery->getId();
        $additionalPrice = appPointPack::getAdditionalPriceByDelivery($this->delivery);
        if ($additionalPrice > 0) {
            $this->price = number_format($additionalPrice, 2, ',', '').' zł';
            // $this->delivery->setName($this->delivery->getName().' (+'.$this->price.')');
        } else 
            $this->price = '';
    }

    public function executeOrderSummary() {
        if(appPointPack::isActive() === false)
            return sfView::NONE;

        if ($this->getRequest()->hasParameter('id') && $this->getRequest()->hasParameter('hash_code')) {
            $id = $this->getRequestParameter('id');
            $hashCode = $this->getRequestParameter('hash_code');
            $order = OrderPeer::retrieveByIdAndHashCode($id, $hashCode);

            if(is_object($order) && is_object($order->getOrderDelivery()) && is_object($order->getOrderDelivery()->getDelivery()) && $order->getOrderDelivery()->getPointpackNumber()) {
                $additionalPrice = appPointPack::getAdditionalPriceByDelivery($order->getOrderDelivery()->getDelivery());
                if ($additionalPrice > 0)
                    $this->price = number_format($additionalPrice, 2, ',', '');
                else 
                    return sfView::NONE;
            } else 
                return sfView::NONE;
        }
    }

    public function executeOrderConfirm() {
        if(appPointPack::isActive() === false)
            return sfView::NONE;

        $this->smarty = new stSmarty('appPointPackFrontend');

        $delivery = stDeliveryFrontend::getInstance(stBasket::getInstance($this->getUser()));
        $additionalPrice = appPointPack::getAdditionalPriceByDelivery($delivery->getDefaultDelivery());
        if ($additionalPrice > 0) {
            $this->price = number_format($additionalPrice, 2, ',', '');
        } else 
            return sfView::NONE;
    }

    public function executeOrderMailToUser() {
        if(appPointPack::isActive() === false)
            return sfView::NONE;

        $this->smarty = new stSmarty('appPointPackFrontend');

        if(is_object($this->order) && is_object($this->order->getOrderDelivery()) && is_object($this->order->getOrderDelivery()->getDelivery()) && $this->order->getOrderDelivery()->getPointpackNumber()) {
                $additionalPrice = appPointPack::getAdditionalPriceByDelivery($this->order->getOrderDelivery()->getDelivery());
                if ($additionalPrice > 0)
                    $this->price = number_format($additionalPrice, 2, ',', '');
                else 
                    return sfView::NONE;
            } else 
                return sfView::NONE;
    }
}
